import { Component } from "@angular/core";
import { TableMonitoringService } from "../monitoring.service";

@Component({
  selector: "app-building",
  templateUrl: "./building.component.html",
  styleUrls: ["./building.component.css"],
})
export class BuildingComponent {
  Data: any;
  public breadcrumb: any;
  feedbacksdonutChart: any;
  donutChart1: any;
  filteredRows: any[];
  data: any[];
  searchTerm: string = "";
  colorChart: string = "";

  constructor(private monitoringService: TableMonitoringService) {}

  ngOnInit() {
    this.breadcrumb = {
      mainlabel: "Dashboard",
      links: [
        {
          name: "Dashboard",
          isLink: false,
        },
      ],
    };

    this.donutChart1 = {
      type: "Pie",
      options: {
        donut: {
          colors: ['#ff0000', '#00ff00', '#0000ff', '#ffff00', '#ff00ff']
        },
        fullwidth: true,
        height: "250px",
        
        donutWidth: 60,
        startAngle: 270,
        total: 200,
        showLabel: false,
      },
    };
    this.fetchData();
  }

  fetchData() {
    this.monitoringService.getMonitoringBuildingData().subscribe((Response) => {
      this.data = Response
      this.filteredRows = Response
      for (let i = 0; i < this.filteredRows.length; i++) {
        if (this.filteredRows[i].donut.series[0] <= 50) {
          this.colorChart = "donut-chart1"
        } else if (this.filteredRows[i].donut.series[0] > 50 && this.filteredRows[i].donut.series[0] < 75) {
          this.colorChart = "donut-chart2"
        } else {
          this.colorChart = "donut-chart3"
        }
      }
    });
  }

  filterRows() {
    if (!this.searchTerm) {
      this.filteredRows = [...this.data];
    } else {
      this.filteredRows = this.data.filter((row) =>
        this.rowContainsSearchTerm(row)
      );
    }
  }

  rowContainsSearchTerm(row: any): boolean {
    const searchTermLC = this.searchTerm.toLowerCase();
    return Object.values(row).some(
      (value) =>
        value !== null && value.toString().toLowerCase().includes(searchTermLC)
    );
  }

}
